libgimpprint API Reference: vars

Main Page | Modules | Alphabetical List | Data Structures | File List | Data Fields | Globals | Related Pages

# vars

The vars data type contains all the information about a print job, this includes information such as the printer model, paper size, print resolution etc. More...

## Data Structures
struct | stp_raw_t
| Raw parameter. More...
struct | stp_double_bound_t
| double_bound (range) parameter. More...
struct | stp_int_bound_t
| int_bound (range) parameter. More...
struct | stp_parameter_t
| Parameter description. More...
## Typedefs
typedef stp_vars | stp_vars_t
| The vars opaque data type.
typedef void * | stp_parameter_list_t
| The parameter_list opaque data type.
typedef const void * | stp_const_parameter_list_t
| The constant parameter_list opaque data type.
typedef void(* | stp_outfunc_t )(void *data, const char *buffer, size_t bytes)
| Output function supplied by the calling application.
typedef void *(* | stp_copy_data_func_t )(void *)
typedef void(* | stp_free_data_func_t )(void *)
typedef stp_compdata | compdata_t
## Enumerations
enum | stp_parameter_type_t { STP_PARAMETER_TYPE_STRING_LIST, STP_PARAMETER_TYPE_INT, STP_PARAMETER_TYPE_BOOLEAN, STP_PARAMETER_TYPE_DOUBLE, STP_PARAMETER_TYPE_CURVE, STP_PARAMETER_TYPE_FILE, STP_PARAMETER_TYPE_RAW, STP_PARAMETER_TYPE_ARRAY, STP_PARAMETER_TYPE_DIMENSION, STP_PARAMETER_TYPE_INVALID }
| Parameter types. More...
enum | stp_parameter_class_t { STP_PARAMETER_CLASS_FEATURE, STP_PARAMETER_CLASS_OUTPUT, STP_PARAMETER_CLASS_CORE, STP_PARAMETER_CLASS_INVALID }
| Parameter class. More...
enum | stp_parameter_level_t { STP_PARAMETER_LEVEL_BASIC, STP_PARAMETER_LEVEL_ADVANCED, STP_PARAMETER_LEVEL_ADVANCED1, STP_PARAMETER_LEVEL_ADVANCED2, STP_PARAMETER_LEVEL_ADVANCED3, STP_PARAMETER_LEVEL_ADVANCED4, STP_PARAMETER_LEVEL_INTERNAL, STP_PARAMETER_LEVEL_EXTERNAL, STP_PARAMETER_LEVEL_INVALID }
| Parameter level. More...
enum | stp_parameter_activity_t { STP_PARAMETER_INACTIVE, STP_PARAMETER_DEFAULTED, STP_PARAMETER_ACTIVE }
| Parameter activity. More...
enum | stp_parameter_verify_t { PARAMETER_BAD, PARAMETER_OK, PARAMETER_INACTIVE }
## Functions
stp_vars_t * | stp_vars_create (void)
| Create a new vars object.
void | stp_vars_copy (stp_vars_t *dest, const stp_vars_t *source)
| Copy a vars object.
stp_vars_t * | stp_vars_create_copy (const stp_vars_t *source)
| Copy and allocate a vars object.
void | stp_vars_destroy (stp_vars_t *v)
| Destroy a vars object.
void | stp_set_driver (stp_vars_t *v, const char *val)
| Set the name of the printer driver.
void | stp_set_driver_n (stp_vars_t *v, const char *val, int bytes)
| Set the name of the printer driver.
const char * | stp_get_driver (const stp_vars_t *v)
| Get the name of the printer driver.
void | stp_set_color_conversion (stp_vars_t *v, const char *val)
| Set the name of the color conversion routine, if not the default.
void | stp_set_color_conversion_n (stp_vars_t *v, const char *val, int bytes)
| Set the name of the color conversion routine, if not the default.
const char * | stp_get_color_conversion (const stp_vars_t *v)
| Get the name of the color conversion routine.
void | stp_set_left (stp_vars_t *v, int val)
| Set the left edge of the image.
int | stp_get_left (const stp_vars_t *v)
| Get the left edge of the image.
void | stp_set_top (stp_vars_t *v, int val)
| Set the top edge of the image.
int | stp_get_top (const stp_vars_t *v)
| Get the top edge of the image.
void | stp_set_width (stp_vars_t *v, int val)
| Set the width of the image.
int | stp_get_width (const stp_vars_t *v)
| Get the width edge of the image.
void | stp_set_height (stp_vars_t *v, int val)
| Set the height of the image.
int | stp_get_height (const stp_vars_t *v)
| Get the height of the image.
void | stp_set_page_width (stp_vars_t *v, int val)
| Set the page width.
int | stp_get_page_width (const stp_vars_t *v)
| Get the page width.
void | stp_set_page_height (stp_vars_t *v, int val)
| Set the page height.
int | stp_get_page_height (const stp_vars_t *v)
| Get the page height.
void | stp_set_outfunc (stp_vars_t *v, stp_outfunc_t val)
| Set the function used to print output information.
stp_outfunc_t | stp_get_outfunc (const stp_vars_t *v)
| Get the function used to print output information.
void | stp_set_errfunc (stp_vars_t *v, stp_outfunc_t val)
| Set the function used to print error and diagnostic information.
stp_outfunc_t | stp_get_errfunc (const stp_vars_t *v)
| Get the function used to print output information.
void | stp_set_outdata (stp_vars_t *v, void *val)
| Set the output data.
void * | stp_get_outdata (const stp_vars_t *v)
| Get the output data.
void | stp_set_errdata (stp_vars_t *v, void *val)
| Set the error data.
void * | stp_get_errdata (const stp_vars_t *v)
| Get the error data.
void | stp_merge_printvars (stp_vars_t *user, const stp_vars_t *print)
| Merge defaults for a printer with user-chosen settings.
stp_parameter_list_t | stp_get_parameter_list (const stp_vars_t *v)
| List the available parameters for the currently chosen settings.
size_t | stp_parameter_list_count (stp_const_parameter_list_t list)
| List the number of available parameters for the currently chosen settings.
const stp_parameter_t * | stp_parameter_find (stp_const_parameter_list_t list, const char *name)
| Find a parameter by its name.
const stp_parameter_t * | stp_parameter_list_param (stp_const_parameter_list_t list, size_t item)
| Find a parameter by its index number.
void | stp_parameter_list_destroy (stp_parameter_list_t list)
| Destroy a parameter_list.
stp_parameter_list_t | stp_parameter_list_create (void)
| Create a parameter_list.
void | stp_parameter_list_add_param (stp_parameter_list_t list, const stp_parameter_t *item)
| Add a parameter to a parameter_list.
stp_parameter_list_t | stp_parameter_list_copy (stp_const_parameter_list_t list)
| Copy and allocate a parameter_list.
void | stp_parameter_list_append (stp_parameter_list_t list, stp_const_parameter_list_t append)
| Append one parameter_list to another.
void | stp_describe_parameter (const stp_vars_t *v, const char *name, stp_parameter_t *description)
| Describe a parameter in detail.
void | stp_parameter_description_destroy (stp_parameter_t *description)
| Destroy a parameter description.
const stp_parameter_t * | stp_parameter_find_in_settings (const stp_vars_t *v, const char *name)
| Find a parameter by its name from a vars object.
void | stp_set_string_parameter (stp_vars_t *v, const char *parameter, const char *value)
| Set a string parameter.
void | stp_set_string_parameter_n (stp_vars_t *v, const char *parameter, const char *value, size_t bytes)
| Set a string parameter.
void | stp_set_file_parameter (stp_vars_t *v, const char *parameter, const char *value)
| Set a file parameter.
void | stp_set_file_parameter_n (stp_vars_t *v, const char *parameter, const char *value, size_t bytes)
| Set a file parameter.
void | stp_set_float_parameter (stp_vars_t *v, const char *parameter, double value)
| Set a float parameter.
void | stp_set_int_parameter (stp_vars_t *v, const char *parameter, int value)
| Set an integer parameter.
void | stp_set_dimension_parameter (stp_vars_t *v, const char *parameter, int value)
| Set a dimension parameter.
void | stp_set_boolean_parameter (stp_vars_t *v, const char *parameter, int value)
| Set a boolean parameter.
void | stp_set_curve_parameter (stp_vars_t *v, const char *parameter, const stp_curve_t *value)
| Set a curve parameter.
void | stp_set_array_parameter (stp_vars_t *v, const char *parameter, const stp_array_t *value)
| Set an array parameter.
void | stp_set_raw_parameter (stp_vars_t *v, const char *parameter, const void *value, size_t bytes)
| Set a raw parameter.
void | stp_scale_float_parameter (stp_vars_t *v, const char *parameter, double scale)
| Multiply the value of a float parameter by a scaling factor.
void | stp_set_default_string_parameter (stp_vars_t *v, const char *parameter, const char *value)
| Set a default string parameter.
void | stp_set_default_string_parameter_n (stp_vars_t *v, const char *parameter, const char *value, size_t bytes)
| Set a default string parameter.
void | stp_set_default_file_parameter (stp_vars_t *v, const char *parameter, const char *value)
| Set a default file parameter.
void | stp_set_default_file_parameter_n (stp_vars_t *v, const char *parameter, const char *value, size_t bytes)
| Set a default file parameter.
void | stp_set_default_float_parameter (stp_vars_t *v, const char *parameter, double value)
| Set a default float parameter.
void | stp_set_default_int_parameter (stp_vars_t *v, const char *parameter, int value)
| Set a default integer parameter.
void | stp_set_default_dimension_parameter (stp_vars_t *v, const char *parameter, int value)
| Set a default dimension parameter.
void | stp_set_default_boolean_parameter (stp_vars_t *v, const char *parameter, int value)
| Set a default boolean parameter.
void | stp_set_default_curve_parameter (stp_vars_t *v, const char *parameter, const stp_curve_t *value)
| Set a default curve parameter.
void | stp_set_default_array_parameter (stp_vars_t *v, const char *parameter, const stp_array_t *value)
| Set a default array parameter.
void | stp_set_default_raw_parameter (stp_vars_t *v, const char *parameter, const void *value, size_t bytes)
| Set a default raw parameter.
const char * | stp_get_string_parameter (const stp_vars_t *v, const char *parameter)
| Get a string parameter.
const char * | stp_get_file_parameter (const stp_vars_t *v, const char *parameter)
| Get a file parameter.
double | stp_get_float_parameter (const stp_vars_t *v, const char *parameter)
| Get a float parameter.
int | stp_get_int_parameter (const stp_vars_t *v, const char *parameter)
| Get an integer parameter.
int | stp_get_dimension_parameter (const stp_vars_t *v, const char *parameter)
| Get a dimension parameter.
int | stp_get_boolean_parameter (const stp_vars_t *v, const char *parameter)
| Get a boolean parameter.
const stp_curve_t * | stp_get_curve_parameter (const stp_vars_t *v, const char *parameter)
| Get a curve parameter.
const stp_array_t * | stp_get_array_parameter (const stp_vars_t *v, const char *parameter)
| Get an array parameter.
const stp_raw_t * | stp_get_raw_parameter (const stp_vars_t *v, const char *parameter)
| Get a raw parameter.
void | stp_clear_string_parameter (stp_vars_t *v, const char *parameter)
| Clear a string parameter.
void | stp_clear_file_parameter (stp_vars_t *v, const char *parameter)
| Clear a file parameter.
void | stp_clear_float_parameter (stp_vars_t *v, const char *parameter)
| Clear (remove) a float parameter.
void | stp_clear_int_parameter (stp_vars_t *v, const char *parameter)
| Clear (remove) an integer parameter.
void | stp_clear_dimension_parameter (stp_vars_t *v, const char *parameter)
| Clear (remove) a dimension parameter.
void | stp_clear_boolean_parameter (stp_vars_t *v, const char *parameter)
| Clear (remove) a boolean parameter.
void | stp_clear_curve_parameter (stp_vars_t *v, const char *parameter)
| Clear a curve parameter.
void | stp_clear_array_parameter (stp_vars_t *v, const char *parameter)
| Clear an array parameter.
void | stp_clear_raw_parameter (stp_vars_t *v, const char *parameter)
| Clear a raw parameter.
void | stp_set_string_parameter_active (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Set the activity of a string parameter.
void | stp_set_file_parameter_active (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Set the activity of a file parameter.
void | stp_set_float_parameter_active (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Set the activity of a float parameter.
void | stp_set_int_parameter_active (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Set the activity of an integer parameter.
void | stp_set_dimension_parameter_active (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Set the activity of a dimension parameter.
void | stp_set_boolean_parameter_active (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Set the activity of a boolean parameter.
void | stp_set_curve_parameter_active (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Set the activity of a curveparameter.
void | stp_set_array_parameter_active (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Set the activity of an array parameter.
void | stp_set_raw_parameter_active (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Set the activity of a raw parameter.
int | stp_check_string_parameter (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Check if a string parameter is set.
int | stp_check_file_parameter (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Check if a file parameter is set.
int | stp_check_float_parameter (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Check if a float parameter is set.
int | stp_check_int_parameter (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Check if an integer parameter is set.
int | stp_check_dimension_parameter (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Check if a dimension parameter is set.
int | stp_check_boolean_parameter (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Check if a boolean parameter is set.
int | stp_check_curve_parameter (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Check if a curve parameter is set.
int | stp_check_array_parameter (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Check if an array parameter is set.
int | stp_check_raw_parameter (const stp_vars_t *v, const char *parameter, stp_parameter_activity_t active)
| Check if a raw parameter is set.
stp_parameter_activity_t | stp_get_string_parameter_active (const stp_vars_t *v, const char *parameter)
| Get the activity status of a string parameter.
stp_parameter_activity_t | stp_get_file_parameter_active (const stp_vars_t *v, const char *parameter)
| Get the activity status of a file parameter.
stp_parameter_activity_t | stp_get_float_parameter_active (const stp_vars_t *v, const char *parameter)
| Get the activity status of a float parameter.
stp_parameter_activity_t | stp_get_int_parameter_active (const stp_vars_t *v, const char *parameter)
| Get the activity status of an integer parameter.
stp_parameter_activity_t | stp_get_dimension_parameter_active (const stp_vars_t *v, const char *parameter)
| Get the activity status of a dimension parameter.
stp_parameter_activity_t | stp_get_boolean_parameter_active (const stp_vars_t *v, const char *parameter)
| Get the activity status of a boolean parameter.
stp_parameter_activity_t | stp_get_curve_parameter_active (const stp_vars_t *v, const char *parameter)
| Get the activity status of a curve parameter.
stp_parameter_activity_t | stp_get_array_parameter_active (const stp_vars_t *v, const char *parameter)
| Get the activity status of an array parameter.
stp_parameter_activity_t | stp_get_raw_parameter_active (const stp_vars_t *v, const char *parameter)
| Get the activity status of a raw parameter.
void | stp_get_media_size (const stp_vars_t *v, int *width, int *height)
| Get the media (paper) size.
void | stp_get_imageable_area (const stp_vars_t *v, int *left, int *right, int *bottom, int *top)
| Get the imagable area of the page.
void | stp_get_size_limit (const stp_vars_t *v, int *max_width, int *max_height, int *min_width, int *min_height)
| Get the media size limits.
void | stp_describe_resolution (const stp_vars_t *v, int *x, int *y)
| Retrieve the printing resolution of the selected resolution.
int | stp_verify (stp_vars_t *v)
| Verify parameters.
const stp_vars_t * | stp_default_settings (void)
| Get default global settings.
void | stp_allocate_component_data (stp_vars_t *v, const char *name, stp_copy_data_func_t copyfunc, stp_free_data_func_t freefunc, void *data)
void | stp_destroy_component_data (stp_vars_t *v, const char *name)
void * | stp_get_component_data (const stp_vars_t *v, const char *name)
stp_parameter_verify_t | stp_verify_parameter (const stp_vars_t *v, const char *parameter, int quiet)
int | stp_get_verified (const stp_vars_t *v)
void | stp_set_verified (stp_vars_t *v, int value)
void | stp_copy_options (stp_vars_t *vd, const stp_vars_t *vs)
void | stp_fill_parameter_settings (stp_parameter_t *desc, const stp_parameter_t *param)

## Detailed Description

The vars data type contains all the information about a print job, this includes information such as the printer model, paper size, print resolution etc.

Most of these job options are expressed as parameters which vary according to the model and other options selected.

The representation of printer settings has changed dramatically from 4.2. All (well most, anyway) settings outside of basics such as the printer model and sizing settings are now typed parameters.

## Typedef Documentation

typedef struct stp_compdata compdata_t

| Definition at line 1332 of file vars.h. Referenced by compdata_copyfunc(), compdata_freefunc(), compdata_namefunc(), stp_allocate_component_data(), and stp_get_component_data().

typedef const void* stp_const_parameter_list_t

| The constant parameter_list opaque data type. Definition at line 185 of file vars.h. Referenced by stp_parameter_find(), stp_parameter_list_append(), stp_parameter_list_copy(), stp_parameter_list_count(), and stp_parameter_list_param().

typedef void*(* stp_copy_data_func_t)(void *)

| Definition at line 1314 of file vars.h. Referenced by stp_allocate_component_data().

typedef void(* stp_free_data_func_t)(void *)

| Definition at line 1315 of file vars.h. Referenced by stp_allocate_component_data().

typedef void(* stp_outfunc_t)(void *data, const char *buffer, size_t bytes)

  | Output function supplied by the calling application. There are two output functions supplied by the caller, one to send output data and one to report errors. Parameters:
  data | a pointer to an opaque object owned by the calling application.
  buffer | the data to output.
  bytes | the size of buffer (in bytes).
Definition at line 196 of file vars.h. Referenced by stp_verify_printer_params().

typedef void* stp_parameter_list_t

| The parameter_list opaque data type. Definition at line 183 of file vars.h. Referenced by escp2_list_parameters(), olympus_list_parameters(), print_debug_params(), ps_list_parameters(), raw_list_parameters(), set_printer_defaults(), stp_dither_list_parameters(), stp_get_parameter_list(), stp_list_generic_parameters(), stp_merge_printvars(), stp_parameter_find_in_settings(), stp_parameter_list_add_param(), stp_parameter_list_append(), stp_parameter_list_copy(), stp_parameter_list_create(), stp_parameter_list_destroy(), stp_prune_inactive_options(), and stp_verify_printer_params().

typedef struct stp_vars stp_vars_t

| The vars opaque data type. Definition at line 57 of file vars.h. Referenced by add_to_row(), adjust_density_and_ink_type(), adjust_print_quality(), allocate_channels(), calculate_pass_map(), canon_print(), check_linebases(), check_parameter_generic(), check_vars(), compute_gcr_curve(), cpx00_plane_init_func(), cpx00_printer_init_func(), cx400_printer_init_func(), escp2_base_res(), escp2_bits(), escp2_density(), escp2_describe_output(), escp2_describe_resolution(), escp2_do_print(), escp2_dropsizes(), escp2_find_resolution(), escp2_get_cap(), escp2_has_advanced_command_set(), escp2_has_cap(), escp2_imageable_area(), escp2_ink_type(), escp2_inklist(), escp2_job_end(), escp2_job_start(), escp2_limit(), escp2_list_parameters(), escp2_paperlist(), escp2_parameters(), escp2_print(), escp2_print_data(), escp2_print_page(), escp2_reset_printer(), escp2_set_color(), escp2_set_dot_size(), escp2_set_form_factor(), escp2_set_graphics_mode(), escp2_set_margins(), escp2_set_page_height(), escp2_set_printer_weave(), escp2_set_printhead_resolution(), escp2_set_printhead_speed(), escp2_set_remote_sequence(), escp2_set_resolution(), escp2_shades(), escp2_use_extended_commands(), finalize_row(), find_default_resolution(), find_resolution_from_quality(), generic_cmy_to_kcmy(), generic_kcmy_to_cmykrb(), get_channel(), get_default_inktype(), get_double_param(), get_inktype(), get_input_slot(), get_media_adjustment(), get_media_type(), get_parameter_active_generic(), get_printer_weave(), get_privdata(), initialize_channel(), initialize_channels(), initialize_gcr_curve(), initialize_raw_weave(), initialize_row(), initialize_weave_params(), input_needs_splitting(), insert_channel(), insert_subchannel(), internal_imageable_area(), lexmark_hue_adjustment(), lexmark_lum_adjustment(), lexmark_print_bidirectional(), lexmark_sat_adjustment(), limit_ink(), olympus_describe_output(), olympus_describe_resolution(), olympus_do_print(), olympus_get_cached_output(), olympus_get_laminate_pattern(), olympus_imageable_area(), olympus_limit(), olympus_list_parameters(), olympus_parameters(), olympus_print(), olympus_printsize(), p10_block_init_func(), p10_printer_end_func(), p10_printer_init_func(), p200_plane_init_func(), p200_printer_end_func(), p200_printer_init_func(), p300_block_init_func(), p300_plane_end_func(), p300_printer_init_func(), p400_block_init_func(), p400_plane_end_func(), p400_plane_init_func(), p400_printer_init_func(), p440_block_end_func(), p440_block_init_func(), p440_printer_end_func(), p440_printer_init_func(), pcl_describe_output(), pcl_print(), postinit_matrix(), preinit_matrix(), print_debug_params(), print_remote_float_param(), print_remote_int_param(), print_remote_param(), ps_ascii85(), ps_describe_output(), ps_describe_resolution(), ps_describe_resolution_internal(), ps_hex(), ps_imageable_area(), ps_imageable_area_internal(), ps_limit(), ps_list_parameters(), ps_media_size(), ps_media_size_internal(), ps_parameters(), ps_parameters_internal(), ps_print(), ps_print_internal(), raw_cmy_to_kcmy(), raw_describe_output(), raw_describe_resolution(), raw_imageable_area(), raw_kcmy_to_cmykrb(), raw_limit(), raw_list_parameters(), raw_parameters(), raw_print(), send_extra_data(), send_print_command(), set_color(), set_color_transition_parameter(), set_density_parameter(), set_gray_transition_parameter(), set_horizontal_position(), set_parameter_active_generic(), set_printer_defaults(), set_raw_ink_type(), set_vertical_position(), setup_channel(), setup_head_offset(), setup_head_parameters(), setup_inks(), setup_misc(), setup_page(), setup_printer_weave_parameters(), setup_resolution(), setup_softweave_parameters(), stp_allocate_component_data(), stp_channel_add(), stp_channel_convert(), stp_channel_get_input(), stp_channel_get_output(), stp_channel_initialize(), stp_channel_reset(), stp_channel_reset_channel(), stp_channel_set_black_channel(), stp_channel_set_cutoff_adjustment(), stp_channel_set_density_adjustment(), stp_channel_set_ink_limit(), stp_clear_array_parameter(), stp_clear_boolean_parameter(), stp_clear_curve_parameter(), stp_clear_dimension_parameter(), stp_clear_file_parameter(), stp_clear_float_parameter(), stp_clear_int_parameter(), stp_clear_raw_parameter(), stp_clear_string_parameter(), stp_color_describe_parameter(), stp_color_get_row(), stp_color_init(), stp_color_list_parameters(), stp_compute_tiff_linewidth(), stp_compute_uncompressed_linewidth(), stp_default_media_size(), stp_default_settings(), stp_describe_output(), stp_describe_parameter(), stp_describe_resolution(), stp_destroy_component_data(), stp_dither(), stp_dither_add_channel(), stp_dither_describe_parameter(), stp_dither_get_channel(), stp_dither_get_first_position(), stp_dither_get_last_position(), stp_dither_init(), stp_dither_internal(), stp_dither_list_parameters(), stp_dither_set_adaptive_limit(), stp_dither_set_ink_spread(), stp_dither_set_inks(), stp_dither_set_inks_full(), stp_dither_set_inks_simple(), stp_dither_set_iterated_matrix(), stp_dither_set_matrix(), stp_dither_set_matrix_from_dither_array(), stp_dither_set_randomizer(), stp_dither_set_transition(), stp_dprintf(), stp_end_job(), stp_eprintf(), stp_fill_tiff(), stp_fill_uncompressed(), stp_flush_all(), stp_flush_debug_messages(), stp_get_array_parameter(), stp_get_boolean_parameter(), stp_get_component_data(), stp_get_curve_parameter(), stp_get_dimension_parameter(), stp_get_file_parameter(), stp_get_float_parameter(), stp_get_imageable_area(), stp_get_int_parameter(), stp_get_lineactive_by_pass(), stp_get_linebases_by_pass(), stp_get_linecount_by_pass(), stp_get_lineoffsets_by_pass(), stp_get_media_size(), stp_get_model_id(), stp_get_parameter_list(), stp_get_pass_by_pass(), stp_get_printer(), stp_get_raw_parameter(), stp_get_size_limit(), stp_get_string_parameter(), stp_get_verified(), stp_init_debug_messages(), stp_initialize_weave(), stp_list_generic_parameters(), stp_merge_printvars(), stp_pack_tiff(), stp_pack_uncompressed(), stp_parameter_find_in_settings(), stp_print(), stp_printer_describe_parameter(), stp_printer_list_parameters(), stp_prune_inactive_options(), stp_put16_be(), stp_put16_le(), stp_put32_be(), stp_put32_le(), stp_putc(), stp_puts(), stp_scale_float_parameter(), stp_send_command(), stp_set_array_parameter(), stp_set_boolean_parameter(), stp_set_curve_parameter(), stp_set_default_array_parameter(), stp_set_default_boolean_parameter(), stp_set_default_curve_parameter(), stp_set_default_dimension_parameter(), stp_set_default_file_parameter(), stp_set_default_file_parameter_n(), stp_set_default_float_parameter(), stp_set_default_int_parameter(), stp_set_default_raw_parameter(), stp_set_default_string_parameter(), stp_set_default_string_parameter_n(), stp_set_dimension_parameter(), stp_set_file_parameter(), stp_set_file_parameter_n(), stp_set_float_parameter(), stp_set_int_parameter(), stp_set_printer_defaults(), stp_set_raw_parameter(), stp_set_string_parameter(), stp_set_string_parameter_n(), stp_set_verified(), stp_start_job(), stp_vars_copy(), stp_vars_create(), stp_vars_create_copy(), stp_vars_destroy(), stp_verify(), stp_verify_parameter(), stp_verify_printer_params(), stp_weave_parameters_by_row(), stp_write_weave(), stp_zfwrite(), stp_zprintf(), stpi_color_convert_raw(), stpi_color_convert_to_cmykrb(), stpi_color_convert_to_color(), stpi_color_convert_to_gray(), stpi_color_convert_to_kcmy(), stpi_color_traditional_describe_parameter(), stpi_color_traditional_get_row(), stpi_color_traditional_init(), stpi_color_traditional_list_parameters(), stpi_compute_lut(), stpi_describe_generic_parameter(), stpi_dither_ed(), stpi_dither_et(), stpi_dither_finalize(), stpi_dither_finalize_ranges(), stpi_dither_ordered(), stpi_dither_predithered(), stpi_dither_set_ranges(), stpi_dither_translate_channel(), stpi_dither_ut(), stpi_dither_very_fast(), stpi_escp2_deinit_printer(), stpi_escp2_flush_pass(), stpi_escp2_init_printer(), stpi_escp2_terminate_page(), stpi_flush_passes(), stpi_get_lineactive(), stpi_get_linebases(), stpi_get_linebounds(), stpi_get_linecount(), stpi_get_lineoffsets(), stpi_get_pass_by_row(), stpi_set_dither_function(), updp10_printer_end_func(), updp10_printer_init_func(), use_printer_weave(), using_automatic_settings(), verify_curve_param(), verify_dimension_param(), verify_double_param(), verify_inktype(), verify_int_param(), verify_papersize(), verify_resolution(), verify_resolution_by_paper_type(), verify_string_param(), and weave_parameters_by_row().

## Enumeration Type Documentation

enum stp_parameter_activity_t

  | Parameter activity. Whether a parameter is currently active (i. e. whether its value should be used by the driver or not). All parameters default to being active unless explicitly "turned off". Enumeration values:
  STP_PARAMETER_INACTIVE | Parameter is inactive (unused).
  STP_PARAMETER_DEFAULTED | Parameter is set to its default value.
  STP_PARAMETER_ACTIVE | Parameter is active (used).
Definition at line 114 of file vars.h.

enum stp_parameter_class_t

  | Parameter class. What kind of setting this is, for the purpose of user interface representation. Enumeration values:
  STP_PARAMETER_CLASS_FEATURE | Printer feature.
  STP_PARAMETER_CLASS_OUTPUT | Output control.
  STP_PARAMETER_CLASS_CORE | Core Gimp-Print parameter.
  STP_PARAMETER_CLASS_INVALID | Invalid class (should never be used).
Definition at line 83 of file vars.h.

enum stp_parameter_level_t

  | Parameter level. What "level" a setting is at, for UI design. Enumeration values:
  STP_PARAMETER_LEVEL_BASIC | Basic parameter, shown by all UIs.
  STP_PARAMETER_LEVEL_ADVANCED | Advanced parameter, shown by advanced UIs.
  STP_PARAMETER_LEVEL_ADVANCED1 | Advanced1 parameter, shown by advanced UIs.
  STP_PARAMETER_LEVEL_ADVANCED2 | Advanced2 parameter, shown by advanced UIs.
  STP_PARAMETER_LEVEL_ADVANCED3 | Advanced3 parameter, shown by advanced UIs.
  STP_PARAMETER_LEVEL_ADVANCED4 | Advanced4 parameter, shown by advanced UIs.
  STP_PARAMETER_LEVEL_INTERNAL | Parameters used only within Gimp-Print.
  STP_PARAMETER_LEVEL_EXTERNAL | Parameters used only outside Gimp-Print.
  STP_PARAMETER_LEVEL_INVALID | Invalid level (should never be used).
Definition at line 95 of file vars.h.

enum stp_parameter_type_t

  | Parameter types. The following types are permitted for a printer setting. Not all are currently implemented. Enumeration values:
  STP_PARAMETER_TYPE_STRING_LIST | Single string choice from a list.
  STP_PARAMETER_TYPE_INT | Integer.
  STP_PARAMETER_TYPE_BOOLEAN | Boolean.
  STP_PARAMETER_TYPE_DOUBLE | Floating point number.
  STP_PARAMETER_TYPE_CURVE | Curve.
  STP_PARAMETER_TYPE_FILE | Filename (NYI, need to consider security).
  STP_PARAMETER_TYPE_RAW | Raw, opaque data.
  STP_PARAMETER_TYPE_ARRAY | Array.
  STP_PARAMETER_TYPE_DIMENSION | Linear dimension.
  STP_PARAMETER_TYPE_INVALID | Invalid type (should never be used).
Definition at line 64 of file vars.h.

enum stp_parameter_verify_t

  | Enumeration values:
  PARAMETER_BAD |
  PARAMETER_OK |
  PARAMETER_INACTIVE |
Definition at line 1317 of file vars.h. Referenced by verify_curve_param(), and verify_string_param().

## Function Documentation

void stp_allocate_component_data | ( | stp_vars_t * | v,
|  | const char * | name,
|  | stp_copy_data_func_t | copyfunc,
|  | stp_free_data_func_t | freefunc,
|  | void * | data
| ) |

| Definition at line 230 of file print-vars.c. References check_vars(), compdata_t, stp_compdata::copyfunc, stp_compdata::data, stp_compdata::freefunc, stp_vars::internal_data, stp_compdata::name, stp_copy_data_func_t, stp_free_data_func_t, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_destroy(), stp_list_item_t, stp_malloc(), stp_strdup(), and stp_vars_t. Referenced by escp2_do_print(), stp_channel_add(), stp_channel_initialize(), stp_dither_init(), stp_initialize_weave(), and stpi_color_traditional_init().

int stp_check_array_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Check if an array parameter is set. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the minimum activity status.
Referenced by stp_dither_init().

int stp_check_boolean_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Check if a boolean parameter is set. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the minimum activity status.
Referenced by adjust_density_and_ink_type(), print_debug_params(), and stpi_compute_lut().

int stp_check_curve_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Check if a curve parameter is set. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the minimum activity status.
Referenced by adjust_print_quality(), initialize_gcr_curve(), olympus_do_print(), print_debug_params(), stpi_compute_lut(), and verify_curve_param().

int stp_check_dimension_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Check if a dimension parameter is set. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the minimum activity status.
Referenced by print_debug_params(), and verify_dimension_param().

int stp_check_file_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Check if a file parameter is set. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the minimum activity status.

int stp_check_float_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Check if a float parameter is set. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the minimum activity status.
Referenced by adjust_density_and_ink_type(), adjust_print_quality(), compute_gcr_curve(), escp2_base_res(), escp2_density(), get_double_param(), initialize_channels(), print_debug_params(), setup_channel(), stp_merge_printvars(), stp_scale_float_parameter(), stpi_compute_lut(), and verify_double_param().

int stp_check_int_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Check if an integer parameter is set. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the minimum activity status.
Referenced by adjust_density_and_ink_type(), escp2_bits(), escp2_ink_type(), print_debug_params(), stp_dither_init(), and verify_int_param().

int stp_check_raw_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Check if a raw parameter is set. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the minimum activity status.

int stp_check_string_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Check if a string parameter is set. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the minimum activity status.
Referenced by escp2_find_resolution(), escp2_inklist(), escp2_parameters(), escp2_print_page(), get_default_inktype(), print_debug_params(), stp_dither_describe_parameter(), stpi_color_traditional_describe_parameter(), stpi_set_dither_function(), using_automatic_settings(), and verify_string_param().

void stp_clear_array_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Clear an array parameter. The parameter is set to NULL. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Definition at line 784 of file print-vars.c. References stp_set_array_parameter(), and stp_vars_t.

void stp_clear_boolean_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Clear (remove) a boolean parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Definition at line 937 of file print-vars.c. References stp_vars::params, stp_list_get_item_by_name(), stp_list_item_destroy(), stp_list_item_t, stp_list_t, STP_PARAMETER_TYPE_BOOLEAN, stp_set_verified(), and stp_vars_t.

void stp_clear_curve_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Clear a curve parameter. The parameter is set to NULL. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Definition at line 710 of file print-vars.c. References stp_set_curve_parameter(), and stp_vars_t.

void stp_clear_dimension_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Clear (remove) a dimension parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Definition at line 1020 of file print-vars.c. References stp_vars::params, stp_list_get_item_by_name(), stp_list_item_destroy(), stp_list_item_t, stp_list_t, STP_PARAMETER_TYPE_DIMENSION, stp_set_verified(), and stp_vars_t.

void stp_clear_file_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Clear a file parameter. The parameter is set to NULL. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Definition at line 635 of file print-vars.c. References stp_set_file_parameter(), and stp_vars_t.

void stp_clear_float_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Clear (remove) a float parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Definition at line 1104 of file print-vars.c. References stp_vars::params, stp_list_get_item_by_name(), stp_list_item_destroy(), stp_list_item_t, stp_list_t, STP_PARAMETER_TYPE_DOUBLE, stp_set_verified(), and stp_vars_t. Referenced by stp_merge_printvars().

void stp_clear_int_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Clear (remove) an integer parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Definition at line 847 of file print-vars.c. References stp_vars::params, stp_list_get_item_by_name(), stp_list_item_destroy(), stp_list_item_t, stp_list_t, STP_PARAMETER_TYPE_INT, stp_set_verified(), and stp_vars_t.

void stp_clear_raw_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Clear a raw parameter. The parameter is set to NULL. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Definition at line 568 of file print-vars.c. References stp_set_raw_parameter(), and stp_vars_t.

void stp_clear_string_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Clear a string parameter. The parameter is set to NULL. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Definition at line 528 of file print-vars.c. References stp_set_string_parameter(), and stp_vars_t.

void stp_copy_options | ( | stp_vars_t * | vd,
|  | const stp_vars_t * | vs
| ) |

const stp_vars_t* stp_default_settings | ( | void |  | ) |

| Get default global settings. The main use of this is to provide a usable stp_vars_t for purposes of parameter inquiry in the absence of a specific printer. This is currently used in a variety of places to get information on the standard color parameters without querying a particular printer. Returns: the default settings. Definition at line 310 of file print-vars.c. References default_vars, initialize_standard_vars(), and stp_vars_t.

void stp_describe_parameter | ( | const stp_vars_t * | v,
|  | const char * | name,
|  | stp_parameter_t * | description
| ) |

  | Describe a parameter in detail. All of the parameter fields will be populated. Parameters:
  v | the vars to use.
  name | the name of the parameter.
  description | a pointer to an stp_parameter_t to store the parameter description in.
Definition at line 1369 of file print-vars.c. References stp_parameter_t::bounds, stp_parameter_t::deflt, stp_parameter_t::p_type, stp_color_describe_parameter(), stp_dither_describe_parameter(), STP_PARAMETER_TYPE_INVALID, stp_printer_describe_parameter(), stp_vars_t, and stpi_describe_generic_parameter(). Referenced by set_printer_defaults(), stp_get_boolean_parameter(), stp_get_dimension_parameter(), stp_get_float_parameter(), stp_get_int_parameter(), stp_merge_printvars(), stp_scale_float_parameter(), stp_verify_parameter(), and stpi_color_traditional_describe_parameter().

void stp_describe_resolution | ( | const stp_vars_t * | v,
|  | int * | x,
|  | int * | y
| ) |

  | Retrieve the printing resolution of the selected resolution. If the resolution is invalid, -1 will be returned in both x and y. Parameters:
  v | the vars to use.
  x | a pointer to a int to store the horizontal resolution in.
  y | a pointer to a int to store the vertical resolution in.
Definition at line 369 of file printers.c. References stp_printfuncs_t::describe_resolution, stp_get_printer(), stp_vars_t, and stpi_get_printfuncs(). Referenced by olympus_do_print().

void stp_destroy_component_data | ( | stp_vars_t * | v,
|  | const char * | name
| ) |

| Definition at line 251 of file print-vars.c. References check_vars(), stp_vars::internal_data, stp_list_get_item_by_name(), stp_list_item_destroy(), stp_list_item_t, and stp_vars_t.

void stp_fill_parameter_settings | ( | stp_parameter_t * | desc,
|  | const stp_parameter_t * | param
| ) |

| Definition at line 1257 of file print-vars.c. References stp_parameter_t::category, stp_parameter_t::channel, stp_parameter_t::help, stp_parameter_t::is_active, stp_parameter_t::is_mandatory, stp_parameter_t::name, stp_parameter_t::p_class, stp_parameter_t::p_level, stp_parameter_t::p_type, stp_parameter_t::read_only, stp_parameter_t::text, and stp_parameter_t::verify_this_parameter. Referenced by escp2_parameters(), lexmark_parameters(), olympus_parameters(), pcl_parameters(), ps_parameters_internal(), raw_parameters(), stp_dither_describe_parameter(), stpi_color_traditional_describe_parameter(), and stpi_describe_generic_parameter().

const stp_array_t* stp_get_array_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get an array parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the array, or NULL if no parameter was found. Definition at line 790 of file print-vars.c. References stp_vars::params, stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, STP_PARAMETER_TYPE_ARRAY, stp_vars_t, and value_t::value. Referenced by stp_dither_init().

stp_parameter_activity_t stp_get_array_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get the activity status of an array parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the activity status.

int stp_get_boolean_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get a boolean parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the boolean value. Definition at line 947 of file print-vars.c. References stp_parameter_t::deflt, stp_parameter_t::p_type, stp_vars::params, stp_describe_parameter(), stp_erprintf(), stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, stp_parameter_description_destroy(), STP_PARAMETER_TYPE_BOOLEAN, stp_vars_t, and value_t::value. Referenced by adjust_density_and_ink_type(), escp2_set_form_factor(), escp2_set_remote_sequence(), internal_imageable_area(), olympus_imageable_area(), print_debug_params(), and stpi_compute_lut().

stp_parameter_activity_t stp_get_boolean_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get the activity status of a boolean parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the activity status.

const char* stp_get_color_conversion | ( | const stp_vars_t * | v | ) |

| Get the name of the color conversion routine. Returns: the name of the color conversion routine (must not be freed). Referenced by stp_color_describe_parameter(), stp_color_get_row(), stp_color_init(), stp_color_list_parameters(), and stp_vars_copy().

void* stp_get_component_data | ( | const stp_vars_t * | v,
|  | const char * | name
| ) |

| Definition at line 261 of file print-vars.c. References check_vars(), compdata_t, stp_vars::internal_data, stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, and stp_vars_t. Referenced by compute_gcr_curve(), finalize_row(), generic_cmy_to_kcmy(), generic_kcmy_to_cmykrb(), get_channel(), get_privdata(), initialize_channel(), initialize_channels(), initialize_gcr_curve(), input_needs_splitting(), limit_ink(), pcl_describe_output(), postinit_matrix(), preinit_matrix(), raw_cmy_to_kcmy(), raw_kcmy_to_cmykrb(), setup_channel(), stp_channel_add(), stp_channel_convert(), stp_channel_get_input(), stp_channel_get_output(), stp_channel_initialize(), stp_channel_reset(), stp_channel_reset_channel(), stp_channel_set_black_channel(), stp_channel_set_ink_limit(), stp_dither_add_channel(), stp_dither_get_channel(), stp_dither_get_first_position(), stp_dither_get_last_position(), stp_dither_internal(), stp_dither_set_adaptive_limit(), stp_dither_set_ink_spread(), stp_dither_set_inks_full(), stp_dither_set_iterated_matrix(), stp_dither_set_matrix(), stp_dither_set_matrix_from_dither_array(), stp_dither_set_randomizer(), stp_dither_set_transition(), stp_fill_tiff(), stp_fill_uncompressed(), stp_get_lineactive_by_pass(), stp_get_linebases_by_pass(), stp_get_linecount_by_pass(), stp_get_lineoffsets_by_pass(), stp_get_pass_by_pass(), stp_weave_parameters_by_row(), stp_write_weave(), stpi_color_convert_raw(), stpi_color_convert_to_cmykrb(), stpi_color_convert_to_color(), stpi_color_convert_to_gray(), stpi_color_convert_to_kcmy(), stpi_color_traditional_get_row(), stpi_compute_lut(), stpi_dither_ed(), stpi_dither_et(), stpi_dither_finalize(), stpi_dither_finalize_ranges(), stpi_dither_ordered(), stpi_dither_predithered(), stpi_dither_set_ranges(), stpi_dither_translate_channel(), stpi_dither_ut(), stpi_dither_very_fast(), stpi_flush_passes(), and stpi_set_dither_function().

const stp_curve_t* stp_get_curve_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get a curve parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the curve, or NULL if no parameter was found. Definition at line 716 of file print-vars.c. References stp_vars::params, stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, STP_PARAMETER_TYPE_CURVE, stp_vars_t, and value_t::value. Referenced by initialize_gcr_curve(), print_debug_params(), setup_channel(), stpi_compute_lut(), and verify_curve_param().

stp_parameter_activity_t stp_get_curve_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get the activity status of a curve parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the activity status. Referenced by setup_channel().

int stp_get_dimension_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get a dimension parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the dimension (integer) value. Definition at line 1030 of file print-vars.c. References stp_parameter_t::deflt, stp_parameter_t::p_type, stp_vars::params, stp_describe_parameter(), stp_erprintf(), stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, stp_parameter_description_destroy(), STP_PARAMETER_TYPE_DIMENSION, stp_vars_t, and value_t::value. Referenced by print_debug_params(), setup_page(), and verify_dimension_param().

stp_parameter_activity_t stp_get_dimension_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get the activity status of a dimension parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the activity status.

const char* stp_get_driver | ( | const stp_vars_t * | v | ) |

| Get the name of the printer driver. Returns: the name of the printer driver (must not be freed). Referenced by cx400_printer_init_func(), print_debug_params(), stp_family_register(), stp_family_unregister(), stp_get_model_id(), stp_get_printer(), stp_printer_create_from_xmltree(), and stp_vars_copy().

void* stp_get_errdata | ( | const stp_vars_t * | v | ) |

  | Get the error data. Parameters:
  v | the vars to use.
Returns: the output data. Referenced by stp_dprintf(), stp_eprintf(), stp_flush_debug_messages(), stp_init_debug_messages(), stp_vars_copy(), and stp_verify_printer_params().

stp_outfunc_t stp_get_errfunc | ( | const stp_vars_t * | v | ) |

  | Get the function used to print output information. Parameters:
  v | the vars to use.
Returns: the outfunc. Referenced by stp_dprintf(), stp_eprintf(), stp_init_debug_messages(), stp_vars_copy(), and stp_verify_printer_params().

const char* stp_get_file_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get a file parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the filename, or NULL if no parameter was found. Definition at line 641 of file print-vars.c. References stp_vars::params, stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, STP_PARAMETER_TYPE_FILE, stp_vars_t, and value_t::value. Referenced by ps_imageable_area_internal(), ps_media_size_internal(), ps_parameters_internal(), and ps_print_internal().

stp_parameter_activity_t stp_get_file_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get the activity status of a file parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the activity status.

double stp_get_float_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get a float parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the float value. Definition at line 1114 of file print-vars.c. References stp_parameter_t::deflt, stp_parameter_t::p_type, stp_vars::params, stp_describe_parameter(), stp_erprintf(), stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, stp_parameter_description_destroy(), STP_PARAMETER_TYPE_DOUBLE, stp_vars_t, and value_t::value. Referenced by adjust_density_and_ink_type(), compute_gcr_curve(), escp2_base_res(), escp2_density(), get_double_param(), initialize_channels(), print_debug_params(), setup_channel(), stp_merge_printvars(), stp_scale_float_parameter(), stpi_compute_lut(), and verify_double_param().

stp_parameter_activity_t stp_get_float_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get the activity status of a float parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the activity status. Referenced by setup_channel().

int stp_get_height | ( | const stp_vars_t * | v | ) |

| Get the height of the image. Returns: the left edge. Referenced by olympus_do_print(), ps_print_internal(), setup_page(), stp_vars_copy(), and stp_verify_printer_params().

void stp_get_imageable_area | ( | const stp_vars_t * | v,
|  | int * | left,
|  | int * | right,
|  | int * | bottom,
|  | int * | top
| ) |

  | Get the imagable area of the page. Retrieve the boundaries of the printable area of the page. In combination with the media size, this can be used to determine the actual printable region, which callers can use to place the image precisely. The dimensions are relative to the top left of the physical page. If a customizable page size is used (see stp_printer_get_media_size), the actual desired width and/or height must be filled in using stp_set_page_width and/or stp_set_page_height. If these are not filled in, the margins will be returned. Returned values may be negative if a printer is capable of full bleed by printing beyond the physical boundaries of the page. If the media size stored in V is invalid, the return values will be indeterminate. It is up to the user to specify legal values. Parameters:
  v | the vars to use.
  left | a pointer to a int to store the left edge in.
  right | a pointer to a int to store the right edge in.
  bottom | a pointer to a int to store the bottom edge in.
  top | a pointer to a int to store the top edge in.
Definition at line 351 of file printers.c. References stp_printfuncs_t::imageable_area, stp_get_printer(), stp_vars_t, and stpi_get_printfuncs(). Referenced by stp_verify_printer_params().

int stp_get_int_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get an integer parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the integer value. Definition at line 857 of file print-vars.c. References stp_parameter_t::deflt, stp_parameter_t::p_type, stp_vars::params, stp_describe_parameter(), stp_erprintf(), stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, stp_parameter_description_destroy(), STP_PARAMETER_TYPE_INT, stp_vars_t, and value_t::value. Referenced by escp2_bits(), escp2_ink_type(), print_debug_params(), stp_dither_init(), stpi_color_traditional_init(), and verify_int_param().

stp_parameter_activity_t stp_get_int_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get the activity status of an integer parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the activity status.

int stp_get_left | ( | const stp_vars_t * | v | ) |

| Get the left edge of the image. Returns: the left edge. Referenced by olympus_do_print(), print_debug_params(), ps_print_internal(), setup_page(), stp_vars_copy(), and stp_verify_printer_params().

void stp_get_media_size | ( | const stp_vars_t * | v,
|  | int * | width,
|  | int * | height
| ) |

  | Get the media (paper) size. Retrieve the media size of the media type set in V, expressed in units of 1/72". If the media size is invalid, width and height will be set to -1. Values of 0 for width or height indicate that the dimension is variable, so that custom page sizes or roll paper can be used. In this case, the size limit should be used to determine maximum and minimum values permitted. Parameters:
  v | the vars to use.
  width | a pointer to an int to store the media width in.
  height | a pointer to an int to store the media height in.
Definition at line 343 of file printers.c. References stp_printfuncs_t::media_size, stp_get_printer(), stp_vars_t, and stpi_get_printfuncs().

void* stp_get_outdata | ( | const stp_vars_t * | v | ) |

  | Get the output data. Parameters:
  v | the vars to use.
Returns: the output data. Referenced by stp_putc(), stp_puts(), stp_vars_copy(), stp_zfwrite(), and stp_zprintf().

stp_outfunc_t stp_get_outfunc | ( | const stp_vars_t * | v | ) |

  | Get the function used to print output information. Parameters:
  v | the vars to use.
Returns: the outfunc. Referenced by stp_putc(), stp_puts(), stp_vars_copy(), stp_zfwrite(), and stp_zprintf().

int stp_get_page_height | ( | const stp_vars_t * | v | ) |

| Get the page height. Returns: the page height. Referenced by olympus_do_print(), print_debug_params(), raw_imageable_area(), raw_print(), stp_default_media_size(), stp_vars_copy(), and stp_verify_printer_params().

int stp_get_page_width | ( | const stp_vars_t * | v | ) |

| Get the page width. Returns: the page width. Referenced by olympus_do_print(), print_debug_params(), raw_imageable_area(), raw_print(), stp_default_media_size(), stp_vars_copy(), and stp_verify_printer_params().

stp_parameter_list_t stp_get_parameter_list | ( | const stp_vars_t * | v | ) |

  | List the available parameters for the currently chosen settings. This does not fill in the bounds and defaults; it merely provides a list of settings. To fill in detailed information for a setting, use stp_describe_parameter. Parameters:
  v | the vars to use.
Returns: a list of available parameters (must be freed with stp_parameter_list_destroy()). Definition at line 602 of file print-util.c. References stp_color_list_parameters(), stp_dither_list_parameters(), stp_list_generic_parameters(), stp_parameter_list_append(), stp_parameter_list_create(), stp_parameter_list_destroy(), stp_parameter_list_t, stp_printer_list_parameters(), and stp_vars_t. Referenced by print_debug_params(), set_printer_defaults(), stp_merge_printvars(), stp_parameter_find_in_settings(), stp_prune_inactive_options(), and stp_verify_printer_params().

const stp_raw_t* stp_get_raw_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get a raw parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the raw data, or NULL if no parameter was found. Definition at line 574 of file print-vars.c. References stp_vars::params, stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, STP_PARAMETER_TYPE_RAW, stp_vars_t, and value_t::value.

stp_parameter_activity_t stp_get_raw_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get the activity status of a raw parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the activity status.

void stp_get_size_limit | ( | const stp_vars_t * | v,
|  | int * | max_width,
|  | int * | max_height,
|  | int * | min_width,
|  | int * | min_height
| ) |

  | Get the media size limits. Retrieve the minimum and maximum size limits for custom media sizes with the current printer settings. Parameters:
  v | the vars to use.
  max_width | a pointer to a int to store the maximum width in.
  max_height | a pointer to a int to store the maximum height in.
  min_width | a pointer to a int to store the minimum width in.
  min_height | a pointer to a int to store the minimum height in.
Definition at line 360 of file printers.c. References stp_printfuncs_t::limit, stp_get_printer(), stp_vars_t, and stpi_get_printfuncs(). Referenced by stp_verify_printer_params().

const char* stp_get_string_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get a string parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the string, or NULL if no parameter was found. Definition at line 534 of file print-vars.c. References stp_vars::params, stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, STP_PARAMETER_TYPE_STRING_LIST, stp_vars_t, and value_t::value. Referenced by escp2_describe_output(), escp2_do_print(), escp2_find_resolution(), escp2_inklist(), escp2_print(), escp2_print_page(), escp2_set_printhead_speed(), get_inktype(), get_input_slot(), get_media_type(), get_printer_weave(), internal_imageable_area(), lexmark_sat_adjustment(), olympus_describe_resolution(), olympus_do_print(), olympus_get_laminate_pattern(), olympus_imageable_area(), olympus_printsize(), pcl_describe_output(), print_debug_params(), ps_describe_output(), ps_describe_resolution_internal(), ps_imageable_area_internal(), ps_media_size_internal(), ps_print_internal(), raw_describe_output(), raw_print(), set_color_transition_parameter(), set_density_parameter(), set_raw_ink_type(), setup_head_parameters(), setup_page(), stp_channel_set_density_adjustment(), stp_default_media_size(), stp_dither_describe_parameter(), stp_end_job(), stp_start_job(), stp_verify_printer_params(), stpi_color_traditional_describe_parameter(), stpi_color_traditional_init(), stpi_set_dither_function(), using_automatic_settings(), and verify_string_param().

stp_parameter_activity_t stp_get_string_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter
| ) |

  | Get the activity status of a string parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
Returns: the activity status.

int stp_get_top | ( | const stp_vars_t * | v | ) |

| Get the top edge of the image. Returns: the left edge. Referenced by olympus_do_print(), print_debug_params(), ps_print_internal(), setup_page(), stp_vars_copy(), and stp_verify_printer_params().

int stp_get_verified | ( | const stp_vars_t * | v | ) |

| Definition at line 413 of file print-vars.c. References check_vars(), stp_vars_t, and stp_vars::verified. Referenced by stp_flush_debug_messages(), stp_init_debug_messages(), stp_vars_copy(), and stp_verify().

int stp_get_width | ( | const stp_vars_t * | v | ) |

| Get the width edge of the image. Returns: the left edge. Referenced by olympus_do_print(), ps_print_internal(), setup_page(), stp_vars_copy(), and stp_verify_printer_params().

void stp_merge_printvars | ( | stp_vars_t * | user,
|  | const stp_vars_t * | print
| ) |

  | Merge defaults for a printer with user-chosen settings. Deprecated: This is likely to go away. Parameters:
  user | the destination vars.
  print | the vars to merge into user.
Definition at line 560 of file print-util.c. References stp_parameter_t::bounds, stp_parameter_t::deflt, stp_parameter_t::name, stp_parameter_t::p_class, stp_parameter_t::p_type, stp_check_float_parameter(), stp_clear_float_parameter(), stp_describe_parameter(), stp_get_float_parameter(), stp_get_parameter_list(), STP_PARAMETER_ACTIVE, STP_PARAMETER_CLASS_OUTPUT, STP_PARAMETER_DEFAULTED, stp_parameter_description_destroy(), stp_parameter_list_count(), stp_parameter_list_destroy(), stp_parameter_list_param(), stp_parameter_list_t, STP_PARAMETER_TYPE_DOUBLE, stp_set_default_float_parameter(), stp_set_float_parameter(), and stp_vars_t.

void stp_parameter_description_destroy | ( | stp_parameter_t * | description | ) |

  | Destroy a parameter description. This must be called even if the stp_parameter_t was not allocated with malloc, since some members are dynamically allocated. Parameters:
  description | the parameter description to destroy.
Definition at line 1389 of file print-vars.c. References stp_parameter_t::bounds, stp_parameter_t::p_type, stp_array_destroy(), stp_curve_destroy(), STP_PARAMETER_TYPE_ARRAY, STP_PARAMETER_TYPE_CURVE, STP_PARAMETER_TYPE_STRING_LIST, and stp_string_list_destroy(). Referenced by set_printer_defaults(), stp_get_boolean_parameter(), stp_get_dimension_parameter(), stp_get_float_parameter(), stp_get_int_parameter(), stp_merge_printvars(), stp_scale_float_parameter(), stp_verify_parameter(), stpi_color_traditional_describe_parameter(), verify_curve_param(), verify_dimension_param(), verify_int_param(), and verify_string_param().

const stp_parameter_t* stp_parameter_find | ( | stp_const_parameter_list_t | list,
|  | const char * | name
| ) |

  | Find a parameter by its name. Parameters:
  list | the parameter_list to use.
  name | the name of the parameter.
Returns: a pointer to the parameter (must not be freed), or NULL if no parameter was found. Definition at line 1430 of file print-vars.c. References stp_const_parameter_list_t, stp_list_get_item_by_name(), stp_list_item_get_data(), stp_list_item_t, and stp_list_t. Referenced by stp_parameter_find_in_settings(), and stp_prune_inactive_options().

const stp_parameter_t* stp_parameter_find_in_settings | ( | const stp_vars_t * | v,
|  | const char * | name
| ) |

  | Find a parameter by its name from a vars object. Parameters:
  v | the vars to use.
  name | the name of the parameter.
Returns: a pointer to the parameter (must not be freed), or NULL if no parameter was found. Definition at line 1414 of file print-vars.c. References stp_get_parameter_list(), stp_parameter_find(), stp_parameter_list_destroy(), stp_parameter_list_t, and stp_vars_t.

void stp_parameter_list_add_param | ( | stp_parameter_list_t | list,
|  | const stp_parameter_t * | item
| ) |

  | Add a parameter to a parameter_list. Parameters:
  list | the parameter_list to use.
  item | the parameter to add.
Definition at line 1361 of file print-vars.c. References stp_list_item_create(), stp_list_t, and stp_parameter_list_t. Referenced by escp2_list_parameters(), olympus_list_parameters(), ps_list_parameters(), raw_list_parameters(), stp_dither_list_parameters(), stp_list_generic_parameters(), and stpi_color_traditional_list_parameters().

void stp_parameter_list_append | ( | stp_parameter_list_t | list,
|  | stp_const_parameter_list_t | append
| ) |

  | Append one parameter_list to another. Parameters:
  list | the destination list (to append to).
  append | the list of paramters to append. Each item that does not already exist in list will be appended.
Definition at line 1469 of file print-vars.c. References stp_parameter_t::name, stp_const_parameter_list_t, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_t, stp_parameter_list_count(), stp_parameter_list_param(), and stp_parameter_list_t. Referenced by stp_get_parameter_list().

stp_parameter_list_t stp_parameter_list_copy | ( | stp_const_parameter_list_t | list | ) |

  | Copy and allocate a parameter_list. A new parameter_list will be created, and then the contents of source will be copied into it. Parameters:
  list | the source parameter_list.
Returns: the new copy of the parameter_list. Definition at line 1458 of file print-vars.c. References stp_const_parameter_list_t, stp_list_item_create(), stp_list_t, stp_parameter_list_count(), stp_parameter_list_create(), stp_parameter_list_param(), and stp_parameter_list_t.

size_t stp_parameter_list_count | ( | stp_const_parameter_list_t | list | ) |

  | List the number of available parameters for the currently chosen settings. Parameters:
  list | the parameter_list to use.
Returns: the number of parameters. Definition at line 1423 of file print-vars.c. References stp_const_parameter_list_t, stp_list_get_length(), and stp_list_t. Referenced by print_debug_params(), set_printer_defaults(), stp_merge_printvars(), stp_parameter_list_append(), stp_parameter_list_copy(), and stp_verify_printer_params().

stp_parameter_list_t stp_parameter_list_create | ( | void |  | ) |

| Create a parameter_list. Returns: the newly created parameter_list. Definition at line 1352 of file print-vars.c. References param_longnamefunc(), param_namefunc(), stp_list_create(), stp_list_set_long_namefunc(), stp_list_set_namefunc(), stp_list_t, and stp_parameter_list_t. Referenced by escp2_list_parameters(), olympus_list_parameters(), ps_list_parameters(), raw_list_parameters(), stp_dither_list_parameters(), stp_get_parameter_list(), stp_list_generic_parameters(), stp_parameter_list_copy(), and stpi_color_traditional_list_parameters().

void stp_parameter_list_destroy | ( | stp_parameter_list_t | list | ) |

  | Destroy a parameter_list. It is an error to destroy the parameter_list more than once. Parameters:
  list | the parameter_list to destroy.
Definition at line 1452 of file print-vars.c. References stp_list_destroy(), stp_list_t, and stp_parameter_list_t. Referenced by print_debug_params(), set_printer_defaults(), stp_get_parameter_list(), stp_merge_printvars(), stp_parameter_find_in_settings(), stp_prune_inactive_options(), and stp_verify_printer_params().

const stp_parameter_t* stp_parameter_list_param | ( | stp_const_parameter_list_t | list,
|  | size_t | item
| ) |

  | Find a parameter by its index number. Parameters:
  list | the parameter_list to use.
  item | the index number of the parameter (must not be greater than stp_parameter_list_count - 1).
Returns: a pointer to the parameter (must not be freed), or NULL if no parameter was found. Definition at line 1441 of file print-vars.c. References stp_const_parameter_list_t, stp_list_get_item_by_index(), stp_list_get_length(), stp_list_item_get_data(), and stp_list_t. Referenced by print_debug_params(), set_printer_defaults(), stp_merge_printvars(), stp_parameter_list_append(), stp_parameter_list_copy(), and stp_verify_printer_params().

void stp_scale_float_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | double | scale
| ) |

  | Multiply the value of a float parameter by a scaling factor. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  scale | the factor to multiply the value by.
Definition at line 1145 of file print-vars.c. References stp_parameter_t::deflt, stp_parameter_t::p_type, stp_check_float_parameter(), stp_describe_parameter(), stp_get_float_parameter(), STP_PARAMETER_DEFAULTED, stp_parameter_description_destroy(), STP_PARAMETER_TYPE_DOUBLE, stp_set_float_parameter(), and stp_vars_t. Referenced by adjust_density_and_ink_type(), and adjust_print_quality().

void stp_set_array_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const stp_array_t * | value
| ) |

  | Set an array parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 731 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_array_create_copy(), stp_array_destroy(), stp_array_t, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_destroy(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_ACTIVE, STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_ARRAY, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value. Referenced by set_printer_defaults(), stp_clear_array_parameter(), and stp_printer_create_from_xmltree().

void stp_set_array_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Set the activity of an array parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the activity status to set (should be set to STP_PARAMETER_ACTIVE or STP_PARAMETER_INACTIVE).
Referenced by set_printer_defaults().

void stp_set_boolean_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | int | value
| ) |

  | Set a boolean parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 888 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_ACTIVE, STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_BOOLEAN, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value. Referenced by set_printer_defaults(), and stp_printer_create_from_xmltree().

void stp_set_boolean_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Set the activity of a boolean parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the activity status to set (should be set to STP_PARAMETER_ACTIVE or STP_PARAMETER_INACTIVE).
Referenced by set_printer_defaults().

void stp_set_color_conversion | ( | stp_vars_t * | v,
|  | const char * | val
| ) |

  | Set the name of the color conversion routine, if not the default. Parameters:
  v | the vars to use.
  val | the name to set.
Referenced by stp_vars_copy().

void stp_set_color_conversion_n | ( | stp_vars_t * | v,
|  | const char * | val,
|  | int | bytes
| ) |

  | Set the name of the color conversion routine, if not the default. Parameters:
  v | the vars to use.
  val | the name to set.
  bytes | the length of val (in bytes).

void stp_set_curve_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const stp_curve_t * | value
| ) |

  | Set a curve parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 656 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_curve_create_copy(), stp_curve_destroy(), stp_curve_t, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_destroy(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_ACTIVE, STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_CURVE, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value. Referenced by adjust_print_quality(), olympus_do_print(), set_printer_defaults(), stp_clear_curve_parameter(), and stp_printer_create_from_xmltree().

void stp_set_curve_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Set the activity of a curveparameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the activity status to set (should be set to STP_PARAMETER_ACTIVE or STP_PARAMETER_INACTIVE).
Referenced by adjust_print_quality(), olympus_do_print(), and set_printer_defaults().

void stp_set_default_array_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const stp_array_t * | value
| ) |

  | Set a default array parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 762 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_array_create_copy(), stp_array_t, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_ARRAY, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value.

void stp_set_default_boolean_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | int | value
| ) |

  | Set a default boolean parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 915 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_BOOLEAN, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value.

void stp_set_default_curve_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const stp_curve_t * | value
| ) |

  | Set a default curve parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 688 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_curve_create_copy(), stp_curve_t, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_CURVE, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value.

void stp_set_default_dimension_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | int | value
| ) |

  | Set a default dimension parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 1002 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_DIMENSION, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value.

void stp_set_default_file_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const char * | value
| ) |

  | Set a default file parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 612 of file print-vars.c. References stp_vars::params, set_default_raw_parameter(), stp_list_t, STP_PARAMETER_TYPE_FILE, stp_set_verified(), and stp_vars_t.

void stp_set_default_file_parameter_n | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const char * | value,
|  | size_t | bytes
| ) |

  | Set a default file parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set (must not contain NUL).
  bytes | the length of value (in bytes).
Definition at line 625 of file print-vars.c. References stp_vars::params, set_default_raw_parameter(), stp_list_t, STP_PARAMETER_TYPE_FILE, stp_set_verified(), and stp_vars_t.

void stp_set_default_float_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | double | value
| ) |

  | Set a default float parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 1085 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_DOUBLE, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value. Referenced by adjust_print_quality(), and stp_merge_printvars().

void stp_set_default_int_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | int | value
| ) |

  | Set a default integer parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 829 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_INT, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value.

void stp_set_default_raw_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const void * | value,
|  | size_t | bytes
| ) |

  | Set a default raw parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
  bytes | the length of value (in bytes).
Definition at line 558 of file print-vars.c. References stp_vars::params, set_default_raw_parameter(), stp_list_t, STP_PARAMETER_TYPE_RAW, stp_set_verified(), and stp_vars_t.

void stp_set_default_string_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const char * | value
| ) |

  | Set a default string parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 509 of file print-vars.c. References STP_DBG_VARS, stp_dprintf(), stp_set_default_string_parameter_n(), stp_set_verified(), and stp_vars_t.

void stp_set_default_string_parameter_n | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const char * | value,
|  | size_t | bytes
| ) |

  | Set a default string parameter. The value is set if the parameter is not already set. This avoids having to check if the parameter is set prior to setting it, if you do not want to override the existing value. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set (must not contain NUL).
  bytes | the length of value (in bytes).
Definition at line 499 of file print-vars.c. References stp_vars::params, set_default_raw_parameter(), stp_list_t, STP_PARAMETER_TYPE_STRING_LIST, stp_set_verified(), and stp_vars_t. Referenced by stp_set_default_string_parameter().

void stp_set_dimension_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | int | value
| ) |

  | Set a dimension parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 978 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_ACTIVE, STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_DIMENSION, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value. Referenced by set_printer_defaults().

void stp_set_dimension_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Set the activity of a dimension parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the activity status to set (should be set to STP_PARAMETER_ACTIVE or STP_PARAMETER_INACTIVE).
Referenced by set_printer_defaults().

void stp_set_driver | ( | stp_vars_t * | v,
|  | const char * | val
| ) |

  | Set the name of the printer driver. Parameters:
  v | the vars to use.
  val | the name to set.
Referenced by stp_printer_create_from_xmltree(), stp_set_printer_defaults(), and stp_vars_copy().

void stp_set_driver_n | ( | stp_vars_t * | v,
|  | const char * | val,
|  | int | bytes
| ) |

  | Set the name of the printer driver. Parameters:
  v | the vars to use.
  val | the name to set.
  bytes | the length of val (in bytes).

void stp_set_errdata | ( | stp_vars_t * | v,
|  | void * | val
| ) |

  | Set the error data. Parameters:
  v | the vars to use.
  val | the error data. This will typically be a file descriptor, but it is entirely up to the caller exactly what type this might be.
Referenced by stp_flush_debug_messages(), stp_init_debug_messages(), stp_vars_copy(), and stp_verify_printer_params().

void stp_set_errfunc | ( | stp_vars_t * | v,
|  | stp_outfunc_t | val
| ) |

  | Set the function used to print error and diagnostic information. These must be supplied by the caller. errdata is passed as an arguments to errfunc; typically it will be a file descriptor. Parameters:
  v | the vars to use.
  val | the value to set.
Referenced by stp_flush_debug_messages(), stp_init_debug_messages(), stp_vars_copy(), and stp_verify_printer_params().

void stp_set_file_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const char * | value
| ) |

  | Set a file parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 589 of file print-vars.c. References stp_vars::params, set_raw_parameter(), stp_list_t, STP_PARAMETER_TYPE_FILE, stp_set_verified(), and stp_vars_t. Referenced by stp_clear_file_parameter().

void stp_set_file_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Set the activity of a file parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the activity status to set (should be set to STP_PARAMETER_ACTIVE or STP_PARAMETER_INACTIVE).

void stp_set_file_parameter_n | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const char * | value,
|  | size_t | bytes
| ) |

  | Set a file parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set (must not contain NUL).
  bytes | the length of value (in bytes).
Definition at line 602 of file print-vars.c. References stp_vars::params, set_raw_parameter(), stp_list_t, STP_PARAMETER_TYPE_FILE, stp_set_verified(), and stp_vars_t.

void stp_set_float_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | double | value
| ) |

  | Set a float parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 1061 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_ACTIVE, STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_DOUBLE, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value. Referenced by adjust_density_and_ink_type(), olympus_do_print(), raw_print(), set_printer_defaults(), stp_merge_printvars(), stp_printer_create_from_xmltree(), and stp_scale_float_parameter().

void stp_set_float_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Set the activity of a float parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the activity status to set (should be set to STP_PARAMETER_ACTIVE or STP_PARAMETER_INACTIVE).
Referenced by adjust_density_and_ink_type(), and set_printer_defaults().

void stp_set_height | ( | stp_vars_t * | v,
|  | int | val
| ) |

  | Set the height of the image. Parameters:
  v | the vars to use.
  val | the value to set.
Referenced by stp_vars_copy().

void stp_set_int_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | int | value
| ) |

  | Set an integer parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 805 of file print-vars.c. References value_t::active, value_t::name, stp_vars::params, stp_list_get_item_by_name(), stp_list_item_create(), stp_list_item_get_data(), stp_list_item_t, stp_list_t, stp_malloc(), STP_PARAMETER_ACTIVE, STP_PARAMETER_DEFAULTED, STP_PARAMETER_TYPE_INT, stp_set_verified(), stp_strdup(), stp_vars_t, value_t::typ, and value_t::value. Referenced by set_printer_defaults(), set_raw_ink_type(), and stp_printer_create_from_xmltree().

void stp_set_int_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Set the activity of an integer parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the activity status to set (should be set to STP_PARAMETER_ACTIVE or STP_PARAMETER_INACTIVE).
Referenced by set_printer_defaults().

void stp_set_left | ( | stp_vars_t * | v,
|  | int | val
| ) |

  | Set the left edge of the image. Parameters:
  v | the vars to use.
  val | the value to set.
Referenced by stp_vars_copy().

void stp_set_outdata | ( | stp_vars_t * | v,
|  | void * | val
| ) |

  | Set the output data. Parameters:
  v | the vars to use.
  val | the output data. This will typically be a file descriptor, but it is entirely up to the caller exactly what type this might be.
Referenced by stp_vars_copy().

void stp_set_outfunc | ( | stp_vars_t * | v,
|  | stp_outfunc_t | val
| ) |

  | Set the function used to print output information. These must be supplied by the caller. outdata is passed as an arguments to outfunc; typically it will be a file descriptor. Parameters:
  v | the vars to use.
  val | the value to set.
Referenced by stp_vars_copy().

void stp_set_page_height | ( | stp_vars_t * | v,
|  | int | val
| ) |

  | Set the page height. Parameters:
  v | the vars to use.
  val | the value to set.
Referenced by stp_vars_copy().

void stp_set_page_width | ( | stp_vars_t * | v,
|  | int | val
| ) |

  | Set the page width. Parameters:
  v | the vars to use.
  val | the value to set.
Referenced by stp_vars_copy().

void stp_set_raw_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const void * | value,
|  | size_t | bytes
| ) |

  | Set a raw parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
  bytes | the length of value (in bytes).
Definition at line 549 of file print-vars.c. References stp_vars::params, set_raw_parameter(), stp_list_t, STP_PARAMETER_TYPE_RAW, stp_set_verified(), and stp_vars_t. Referenced by stp_clear_raw_parameter().

void stp_set_raw_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Set the activity of a raw parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the activity status to set (should be set to STP_PARAMETER_ACTIVE or STP_PARAMETER_INACTIVE).

void stp_set_string_parameter | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const char * | value
| ) |

  | Set a string parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set.
Definition at line 481 of file print-vars.c. References STP_DBG_VARS, stp_dprintf(), stp_set_string_parameter_n(), stp_set_verified(), and stp_vars_t. Referenced by allocate_channels(), olympus_do_print(), ps_print_internal(), raw_print(), set_printer_defaults(), set_raw_ink_type(), stp_clear_string_parameter(), and stp_printer_create_from_xmltree().

void stp_set_string_parameter_active | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | stp_parameter_activity_t | active
| ) |

  | Set the activity of a string parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  active | the activity status to set (should be set to STP_PARAMETER_ACTIVE or STP_PARAMETER_INACTIVE).
Referenced by set_printer_defaults().

void stp_set_string_parameter_n | ( | stp_vars_t * | v,
|  | const char * | parameter,
|  | const char * | value,
|  | size_t | bytes
| ) |

  | Set a string parameter. Parameters:
  v | the vars to use.
  parameter | the name of the parameter.
  value | the value to set (must not contain NUL).
  bytes | the length of value (in bytes).
Definition at line 465 of file print-vars.c. References stp_vars::params, set_raw_parameter(), STP_DBG_VARS, stp_dprintf(), stp_list_t, STP_PARAMETER_TYPE_STRING_LIST, stp_set_verified(), and stp_vars_t. Referenced by stp_set_string_parameter().

void stp_set_top | ( | stp_vars_t * | v,
|  | int | val
| ) |

  | Set the top edge of the image. Parameters:
  v | the vars to use.
  val | the value to set.
Referenced by stp_vars_copy().

void stp_set_verified | ( | stp_vars_t * | v,
|  | int | value
| ) |

| Definition at line 406 of file print-vars.c. References check_vars(), stp_vars_t, and stp_vars::verified. Referenced by stp_clear_boolean_parameter(), stp_clear_dimension_parameter(), stp_clear_float_parameter(), stp_clear_int_parameter(), stp_flush_debug_messages(), stp_init_debug_messages(), stp_set_array_parameter(), stp_set_boolean_parameter(), stp_set_curve_parameter(), stp_set_default_array_parameter(), stp_set_default_boolean_parameter(), stp_set_default_curve_parameter(), stp_set_default_dimension_parameter(), stp_set_default_file_parameter(), stp_set_default_file_parameter_n(), stp_set_default_float_parameter(), stp_set_default_int_parameter(), stp_set_default_raw_parameter(), stp_set_default_string_parameter(), stp_set_default_string_parameter_n(), stp_set_dimension_parameter(), stp_set_file_parameter(), stp_set_file_parameter_n(), stp_set_float_parameter(), stp_set_int_parameter(), stp_set_raw_parameter(), stp_set_string_parameter(), stp_set_string_parameter_n(), stp_vars_copy(), stp_verify(), and stp_verify_printer_params().

void stp_set_width | ( | stp_vars_t * | v,
|  | int | val
| ) |

  | Set the width of the image. Parameters:
  v | the vars to use.
  val | the value to set.
Referenced by stp_vars_copy().

void stp_vars_copy | ( | stp_vars_t * | dest,
|  | const stp_vars_t * | source
| ) |

  | Copy a vars object. Both dest and source must be valid vars objects previously created with stp_vars_create(). Parameters:
  dest | the destination vars.
  source | the source vars.
Definition at line 1279 of file print-vars.c. References copy_compdata_list(), copy_value_list(), stp_vars::internal_data, stp_vars::params, stp_get_color_conversion(), stp_get_driver(), stp_get_errdata(), stp_get_errfunc(), stp_get_height(), stp_get_left(), stp_get_outdata(), stp_get_outfunc(), stp_get_page_height(), stp_get_page_width(), stp_get_top(), stp_get_verified(), stp_get_width(), stp_list_destroy(), STP_PARAMETER_TYPE_INVALID, stp_set_color_conversion(), stp_set_driver(), stp_set_errdata(), stp_set_errfunc(), stp_set_height(), stp_set_left(), stp_set_outdata(), stp_set_outfunc(), stp_set_page_height(), stp_set_page_width(), stp_set_top(), stp_set_verified(), stp_set_width(), and stp_vars_t. Referenced by stp_vars_create(), and stp_vars_create_copy().

stp_vars_t* stp_vars_create | ( | void |  | ) |

| Create a new vars object. Returns: the newly created vars object. Definition at line 317 of file print-vars.c. References create_compdata_list(), create_vars_list(), default_vars, initialize_standard_vars(), stp_vars::internal_data, stp_vars::params, STP_PARAMETER_TYPE_INVALID, stp_vars_copy(), stp_vars_t, and stp_zalloc(). Referenced by stp_printer_create_from_xmltree(), and stp_vars_create_copy().

stp_vars_t* stp_vars_create_copy | ( | const stp_vars_t * | source | ) |

  | Copy and allocate a vars object. source must be a valid vars object previously created with stp_vars_create(). Parameters:
  source | the source vars.
Returns: the new copy of the vars. Definition at line 1330 of file print-vars.c. References stp_vars_copy(), stp_vars_create(), and stp_vars_t. Referenced by escp2_job_end(), escp2_job_start(), escp2_print(), olympus_print(), ps_print_internal(), raw_print(), and stp_verify().

void stp_vars_destroy | ( | stp_vars_t * | v | ) |

  | Destroy a vars object. It is an error to destroy the vars more than once. Parameters:
  v | the vars to destroy.
Definition at line 330 of file print-vars.c. References check_vars(), stp_vars::color_conversion, stp_vars::driver, stp_vars::internal_data, stp_vars::params, stp_free(), stp_list_destroy(), STP_PARAMETER_TYPE_INVALID, STP_SAFE_FREE, and stp_vars_t. Referenced by escp2_job_end(), escp2_job_start(), escp2_print(), olympus_print(), ps_print_internal(), raw_print(), and stp_verify().

int stp_verify | ( | stp_vars_t * | v | ) |

  | Verify parameters. Verify that the parameters selected are consistent with those allowed by the driver. This must be called prior to printing; failure to do so will result in printing failing. Parameters:
  v | the vars to use.
Returns: 0 on failure, 1 on success; other status values are reserved. Definition at line 385 of file printers.c. References stp_get_printer(), stp_get_verified(), stp_prune_inactive_options(), stp_set_verified(), stp_vars_create_copy(), stp_vars_destroy(), stp_vars_t, stpi_get_printfuncs(), and stp_printfuncs_t::verify. Referenced by escp2_do_print(), olympus_do_print(), ps_print_internal(), and raw_print().

stp_parameter_verify_t stp_verify_parameter | ( | const stp_vars_t * | v,
|  | const char * | parameter,
|  | int | quiet
| ) |

| Definition at line 595 of file printers.c. References _, stp_parameter_t::is_active, stp_parameter_t::p_type, PARAMETER_INACTIVE, PARAMETER_OK, stp_parameter_t::read_only, STP_DBG_VARS, stp_describe_parameter(), stp_dprintf(), stp_eprintf(), stp_parameter_description_destroy(), STP_PARAMETER_TYPE_BOOLEAN, STP_PARAMETER_TYPE_CURVE, STP_PARAMETER_TYPE_DIMENSION, STP_PARAMETER_TYPE_DOUBLE, STP_PARAMETER_TYPE_FILE, STP_PARAMETER_TYPE_INT, STP_PARAMETER_TYPE_RAW, STP_PARAMETER_TYPE_STRING_LIST, stp_vars_t, verify_curve_param(), verify_dimension_param(), verify_double_param(), verify_int_param(), and verify_string_param(). Referenced by stp_verify_printer_params(), and stpi_color_traditional_init().